import preprocess from "svelte-preprocess";
import adapter from '@sveltejs/adapter-static'

/** @type {import('@sveltejs/kit').Config} */
const config = {
	// Consult https://github.com/sveltejs/svelte-preprocess
	// for more information about preprocessors
	preprocess: [
		preprocess({
			postcss: true,
		}),
	],

	kit: {
		// hydrate the <div id="svelte"> element in src/app.html
		target: "#svelte",
		files: {
			hooks: "web_src/hooks",
			lib: "web_src/lib",
			routes: "web_src/routes",
			serviceWorker: "web_src/service-worker",
			template: "web_src/app.html",
		},
		adapter: adapter({}),
	},
};

export default config;
